<?php

/*
=====================================================
 I-Soft Bizness -    I-Soft
-----------------------------------------------------
 http://vkaragande.info/
-----------------------------------------------------
 Created by D.Madi
=====================================================
 : functions.php
-----------------------------------------------------
 :  
=====================================================
*/


function safeHTML ( $str )

{

	$str = preg_replace ( "'<script[^>]*?>.*?</script>'si", "", $str );
	$str = preg_replace ( "'<head[^>]*?>.*?</head>'si", "", $str );

	$allowed = "b|i|u|a";

	$str = preg_replace ( "/<((?!\/?($allowed)\b)[^>]*>)/xis", "", $str );
	$str = preg_replace ( "/<($allowed).*?>/i", "<\\1>", $str );

	$str = htmlspecialchars ( $str, ENT_QUOTES );

	$str = preg_replace("/ +/", " ", $str);

	$str = preg_replace("/(\r\n|\n|\r)/", "\n", $str); // cross-platform newlines
	$str = preg_replace("/\n\n+/", "\n\n", $str); // take care of duplicates
	$str = str_replace("\n", "<br>", $str);

	return $str;

}


function unHTML ( $str )

{

	$str = str_replace ( "&amp;", "&", $str );
	$str = str_replace ( "&quot;", "\"", $str );
	$str = str_replace ( "&#039;", "\'", $str );
	$str = str_replace ( "&lt;", "<", $str );
	$str = str_replace ( "&gt;", ">", $str );
	//     $str = html_entity_decode ( $str );

	$trans_tbl = get_html_translation_table (HTML_ENTITIES);
	$trans_tbl = array_flip ($trans_tbl);
	$str = strtr ($str, $trans_tbl);
	$str = preg_replace('/\&\#([0-9]+)\;/me', "chr('\\1')", $str);

	return $str;

}

function safeInfo($text)
{
	#  
	$allowed = array('strong', 'em', 'u', 'p', 'br', 'span', 'div', 'ol', 'li', 'ul', 'BLOCKQUOTE', 'hr');
	
	#    
	$cutted = array('iframe', 'script', 'a', 'img');

	#    
	$cuttag = array ('http', 'https', 'ftp', 'alert', 'script', 'iframe');
	
	$list = array();
	foreach ($allowed as $tag)
	{
		$list[] = '#<(' . $tag . '[^>]*)>#i';
		$list[] = '#<(/' . $tag . ')>#i';
	}
	
	$text = preg_replace($list, '###$1|||', $text);
	
	foreach ($cutted as $tag)
	{
		do
		{
			$tag1 = '<' . $tag;
			$tag2 = '</' . $tag . '>';
			$p1 = stripos($text, $tag1);
			$p2 = stripos($text, $tag2, $p1);
			if ($p1 === false && $p2 === false)
			{
				break;
			}
			elseif ($p1 === false && $p2 !== false)
			{
				$text = substr_replace($text, '', $p2, strlen($tag2));
			}
			elseif ($p1 !== false && $p2 === false)
			{
				$p2 = strpos($text, '>', $p1);
				if ($p2 !== false)
				{
					$text = substr_replace($text, '', $p1, ($p2 + 1) - $p1);
				}
				else
				{
					$text = substr_replace($text, '', $p1, strlen($tag1));
				}
			}
			else
			{
				$text = substr_replace($text, '', $p1, ($p2 + strlen($tag2)) - $p1);
			}
		}
		while (true);
	}
	
	$text = str_replace(array('<', '>'), array('&lt;', '&gt;'), $text);
	
	$text = str_replace(array('###', '|||'), array('<', '>'), $text);
	
	$text = preg_replace('#((\s|&nbsp;|&32;){3})(\s|&nbsp;|&32;)+#', '$1', $text);
	$text = preg_replace('#((<br[^>]*>\s*){3})(<br[^>]*>\s*)+#i', '$1', $text);

	foreach ($cuttag as $tag)
	{
 		$text = str_replace($tag,'',$text);
	}
	
	return $text;
} 


function rewrite ($str)

{

//   "" .

    $str=strtr($str,"_",

    "abvgdeeziyklmnoprstufh'iei");

    $str=strtr($str,"Ũ_",

    "ABVGDEEZIYKLMNOPRSTUFH'IEI");

    //  - "".

    $str=strtr($str, 

                    array(

                        ""=>"zh", ""=>"ts", ""=>"ch", ""=>"sh", 

                        ""=>"shch",""=>"", ""=>"yu", ""=>"ya",

                        ""=>"ZH", ""=>"TS", ""=>"CH", ""=>"SH", 

                        ""=>"SHCH",""=>"", ""=>"YU", ""=>"YA",

                        ""=>"i", ""=>"Yi", ""=>"ie", ""=>"Ye"

                        )

             );



	$str=trim($str);	
	$str=str_replace(' ', "-", $str);
	$str=str_replace('/', "", $str);
	$str=str_replace(',', "", $str);
	return $str;

}

function undate ( $str2, $type )

{

	$str = explode ( "-", $str2 );

	$str_year = $str[0];

	if (strlen($str[1]) < 2)
	$str_month = "0". $str[1];
	else
	$str_month = $str[1];

	if (strlen($str[2]) < 2)
	$str_day = "0". $str[2];
	else
	$str_day = $str[2];

	if ($type == "MM-DD-YYYY") $str2 = "$str_month-$str_day-$str_year";
	elseif ($type == "DD-MM-YYYY") $str2 = "$str_day-$str_month-$str_year";
	elseif ($type == "YYYY-MM-DD") $str2 = "$str_year-$str_month-$str_day";
	elseif ($type == "YYYY-DD-MM") $str2 = "$str_year-$str_day-$str_month";
	elseif ($type == "DD.MM.YYYY") $str2 = "$str_day.$str_month.$str_year";
	else $str2 = "Incorrect date type setting in config.php ($type)";

	return $str2;

}


/* ************************************************************************* */

// Template class.

class Template {

	var $template;


	// Load the html template

	function load ($file)

	{
		$this->template = $file;
	}


	// Function which replaces the variables

	function replace ($var, $content)

	{
		$this->template = str_replace("*$var*", $content, $this->template);
	}


	// Publish the template

	function publish ()

	{
		eval("?>".$this->template."<?");
	}

}



/* ************************************************************************* */


//    


function parseDescription ($flag, $description)

{

	global $def_A_description;
	global $def_B_description;
	global $def_C_description;
	global $def_D_description;

	global $def_A_descr_size;
	global $def_B_descr_size;
	global $def_C_descr_size;
	global $def_D_descr_size;
	
	global $def_box_descr_size;
	global $def_short_descr_size;

	if( function_exists( "get_magic_quotes_gpc" ) && get_magic_quotes_gpc() ) $description = stripslashes( $description );

	$var = "def_" . $flag . "_description";

	if ( ($$var == "YES") and ($description != "") )

	{

		if ($flag == "A") $descr_size_max = $def_A_descr_size;
		if ($flag == "B") $descr_size_max = $def_B_descr_size;
		if ($flag == "C") $descr_size_max = $def_C_descr_size;
		if ($flag == "D") $descr_size_max = $def_D_descr_size;

		if (strlen($description) > $descr_size_max)
			{
				$descr = substr($description, 0, $descr_size_max);
				$descr = substr($descr, 0, strrpos($descr, ' '));
				$descr = trim($descr) . ' ...';
			}

		else $descr=$description;
	}

	if ( ($flag == "X") and ($description != "") ) $descr = substr ($description, 0, $def_short_descr_size) .  "...";
	if ( ($flag == "Z") and ($description != "") ) $descr = substr ($description, 0, $def_box_descr_size); 

		If (($flag != "D") and ($flag != "X") and ($flag != "Z") and ($flag != "I"))
		{ 
			$descr=str_replace("[", "<", $descr);
			$descr=str_replace("]", ">", $descr);
		}
		else
		{ 
			$descr=str_replace("[b]", "", $descr);
			$descr=str_replace("[/b]", "", $descr);
			$descr=str_replace("[i]", "", $descr);
			$descr=str_replace("[/i]", "", $descr);
			$descr=str_replace("[u]", "", $descr);
			$descr=str_replace("[/u]", "", $descr);
		}

	return "$descr";

}

/* ************************************************************************* */

// 

function ifNew ($date)

{

	if ($date=="") { $new_listing = ""; return $new_listing; }

	global $def_new;

	$date_day = date ( "d" );
	$date_month = date ( "m" );
	$date_year = date ( "Y" );

	list ( $on_year, $on_month, $on_day ) = preg_split ( '#[/.-]#', $date );

	$first_date = mktime ( 0,0,0,$on_month,$on_day,$on_year );
	$second_date = mktime ( 0,0,0,$date_month,$date_day,$date_year );

	if ( $second_date > $first_date )

	{

		$days = $second_date - $first_date;

	}

	else

	{

		$days = $first_date - $second_date;

	}

	$current_result = ( $days ) / ( 60 * 60 * 24 );

	if ( $current_result <= 5 )

	{

		$new_listing = "$def_new";

	}

	else

	{

		$new_listing = "";

	}

	return $new_listing;

}

/* ************************************************************************* */

// 

function ifHot ($countrating, $votes)

{

	global $def_hot;

	if ( ( $countrating == 5 ) and ( $votes > 5 ) )

	{

		$hot_listing = "$def_hot";

	}

	else

	{

		$hot_listing = "";

	}

	return $hot_listing;

}

/* ************************************************************************* */

// 

function ifUpdated ($date)

{

IF ($date<>"") {

	global $def_updated;


	$date_day = date ( "d" );
	$date_month = date ( "m" );
	$date_year = date ( "Y" );

	list ( $on_year, $on_month, $on_day ) = preg_split ( '#[/.-]#', $date );     
	$first_date = mktime ( 0,0,0,$on_month,$on_day,$on_year );
	$second_date = mktime ( 0,0,0,$date_month,$date_day,$date_year );

	if ( $second_date > $first_date )

	{

		$days = $second_date - $first_date;

	}

	else

	{

		$days = $first_date - $second_date;

	}

	$current_result = ( $days ) / ( 60 * 60 * 24 );

	if ( $current_result <= 5 )

	{

		$updated_listing = "$def_updated";

	}

	else

	{

		$updated_listing = "";

	}

}
else

{
$updated_listing = "";
}

	return $updated_listing;

}

/* ************************************************************************* */

// 

function ifLogo ($flag, $selector, $width)

{

	// Predefine the required
	// global variables

	global $def_A_logo;
	global $def_B_logo;
	global $def_C_logo;
	global $def_D_logo;
	global $def_mainlocation;

	// Loading all logo images from the /logo
	// folder

	$handle = opendir ( "./logo" );

	$count = 0;

	while ( false != ( $file = readdir ( $handle ) ) )

	{

		if ( $file != "." && $file != ".." )

		{
			$logo[$count] = "$file";
			$count++;
		}
	}

	closedir ( $handle );

	// Checking if the image from this
	// listing exist

	$logotag = "";

	for ( $a=0; $a<count($logo); $a++ )

	{

		$logoname = explode ( ".", $logo[$a] );

		if ( $logoname[0] == $selector )

		{

			// If exist we check if the logo
			// is enabled for this membership

			$logovar =  "def_".$flag."_logo";

			// If enabled we generate the logo image tag

			if ($width != "") $width_out = "width=$width"; else $width_out = "";
		
			if ($$logovar == "YES")
			{

				$logotag = "<img src=\"$def_mainlocation/logo/$logoname[0].$logoname[1]\" $width_out alt=\"\" border=0>";

			}

			else

			$logotag = "";
		}

	}

	return $logotag;

}

/* ************************************************************************* */

//  

function ifSxema ($flag, $selector, $width)

{

	// Predefine the required
	// global variables

	global $def_A_sxema;
	global $def_B_sxema;
	global $def_C_sxema;
	global $def_D_sxema;
	global $def_mainlocation;

	// Loading all logo images from the /logo
	// folder

	$handle = opendir ( "./sxema" );

	$count = 0;

	while ( false != ( $file = readdir ( $handle ) ) )

	{

		if ( $file != "." && $file != ".." )

		{
			$sxema[$count] = "$file";
			$count++;
		}
	}

	closedir ( $handle );

	// Checking if the image from this
	// listing exist

	$sxematag = "";

	for ( $a=0; $a<count($sxema); $a++ )

	{

		$sxemaname = explode ( ".", $sxema[$a] );

		if ( $sxemaname[0] == $selector )

		{

			// If exist we check if the logo
			// is enabled for this membership

			$sxemavar =  "def_".$flag."_sxema";

			// If enabled we generate the sxema image tag

			if ($width != "") $width_out = "width=$width"; else $width_out = "";
		
			if ($$sxemavar == "YES")
			{

				$sxematag = "<img src=\"$def_mainlocation/sxema/$sxemaname[0].$sxemaname[1]\" alt=\" \" width=\"40\" height=\"40\" border=0 hspace=3 align=absmiddle> <a href=\"$def_mainlocation/sxema/$sxemaname[0].$sxemaname[1]\" target=\"_blank\"> </a>";

			}

			else

			$sxematag = "";
		}

	}

	return $sxematag;

}


/* ************************************************************************* */

//  /   

function ifEnabled ($flag, $field)

{

	$fieldvar =  "def_".$flag."_".$field;

	include ("./conf/memberships.php");

	// If the field is enabled we return True

	if ($$fieldvar == "YES")
	return True;
	else
	return False;

}

/* ************************************************************************* */

//  

function show_rating ($countrating, $votes)

{

	global $def_rating_allowed;
	global $def_rating;
	global $def_cat_font_color_empty;
	global $def_votes;
	global $def_template;
	global $def_mainlocation;

	if ( ( $def_rating_allowed == "YES" ) and ( $countrating > 0 ) and ( $votes > 0 ) )

	{

		$countrating = $countrating / $votes;

		$rating_listing = "";

		for ( $i=1;$i<6;$i++ )

		{

 		 if ($countrating - $i >= 0)

		  {

			$rating_listing.= "<img src='" . $def_mainlocation . "/template/" . $def_template . "/images/star.gif' border='0' alt='' />";

		  }

		else

		  {

			if ( (($i - $countrating) <= 0.5) and (($i - $countrating) > 0) )
  	                $rating_listing.= "<img src='" . $def_mainlocation . "/template/" . $def_template . "/images/star-half.gif' border='0' alt='' />";
			else
  	                $rating_listing.= "<img src='" . $def_mainlocation . "/template/" . $def_template . "/images/star-empty.gif' border='0' alt='' />";

		  }

		}

		$rating_listing.= " <font color='#808080'> ($votes $def_votes) </font>";

	}

	return $rating_listing;

}

/* ************************************************************************* */

//   

function error ($type, $message)

{

	echo "<font face=arial size=4><b>$type</b></font>\n
          <br ><br >
           <font face=arial size=2 color=#808080>$message</font>";
	exit();

}

/* ************************************************************************* */

// TITLE 

function title ($text)

{

 global $def_title;

  $text = preg_replace ( "/<((?!\/?($allowed)\b)[^>]*>)/xis", "", $text );
  $text = preg_replace ( "/<($allowed).*?>/i", "<\\1>", $text );
  $text = str_replace(">", "", $text);
  $text = str_replace("<", "", $text);

  echo $text . "-" . $def_title;

}

/* ************************************************************************* */

//   

function check_smartphone() {

	$phone_array = array('iphone', 'pocket', 'palm', 'windows ce', 'windowsce', 'cellphone', 'opera mobi', 'ipod', 'small', 'sharp', 'sonyericsson', 'symbian', 'opera mini', 'nokia', 'htc_', 'samsung', 'motorola', 'smartphone', 'blackberry', 'playstation portable', 'tablet browser');
	$agent = strtolower( $_SERVER['HTTP_USER_AGENT'] );

	foreach ($phone_array as $value) {

		if ( strpos($agent, $value) !== false ) return true;

	}

	return false;

}

/* ************************************************************************* */

//  compare.php

function ifcompare ($iftarif)

{
	global $def_mainlocation;

	if ($iftarif=="YES")

		echo "<img src=\"$def_mainlocation/images/compare/YES.gif\" border=\"0\" alt=\"\" title=\"\">";

	else 

		echo "<img src=\"$def_mainlocation/images/compare/NO.gif\" border=\"0\" alt=\"\" title=\"\">";
}

// md5 

function my_crypt($pass)
{

	global $salt;

	$spec=array('~','!','@','#','$','%','^','&','*','?');
	$crypted=md5(md5($salt).md5($pass));
	$c_text=md5($pass);
	for ($i=0;$i<strlen($crypted);$i++)
	{
	if (ord($c_text[$i])>=48 and ord($c_text[$i])<=57){
		@$temp.=$spec[$c_text[$i]];
	} elseif(ord($c_text[$i])>=97 and ord($c_text[$i])<=100){
		@$temp.=strtoupper($crypted[$i]);
	} else {
		@$temp.=$crypted[$i];
	}
	}
	return md5($temp);
}

//  

function check_loginup ($idf, $login, $passw, $num_rows, $login1, $passw1, $passwmd5)
{

	global $db_users;

	if (($login==$login1) and ($passw==mysql_escape_string(md5($passwmd5))) and ($num_rows==1)) {

		$passmd=my_crypt($passwmd5);
		$sql = "UPDATE $db_users SET pass='$passmd' WHERE selector='$idf'" ;
		$rfg = mysql_query ($sql);

	return true; }

	if (($login==$login1) and ($passw==$passw1) and ($num_rows==1)) return true;

return false;

}

?>